package PC20050329;
import ProSW.*;
public class Azienda {
	private final String nome;
	private String sede;
	private final String pIVA;
	private int capSociale;
	
	public Azienda(String n, String s, String iva, int cap) throws EccezionePrecondizioni {
		if (n==null) throw new EccezionePrecondizioni("Il nome non puo' essere null");
		nome=n;
		setSede(s);
		if (iva==null) throw new EccezionePrecondizioni("La p. iva non puo' essere null");
		pIVA=iva;
		setCapSociale(cap);
	}
	public String getNome() { return nome; }
	public String getSede() { return sede; }
	public String getpIVA() { return pIVA; }
	public int getCapSociale()  { return capSociale; }
	
	public void setSede(String s) throws EccezionePrecondizioni { 
		if (s==null) throw new EccezionePrecondizioni("La sede non puo' essere null");
		sede=s; 
	}
	public void setCapSociale(int cap) throws EccezionePrecondizioni {
		if (cap<=0) throw new EccezionePrecondizioni("Il capitale sociale deve essere positivo");
		capSociale=cap;	
	}

	public boolean isMedioGrande() {
		return capSociale > 10000000;
	}
} //:~
