package PC20050329;

import ProSW.*;

public abstract class Collezione {	
	protected final int codiceCollezione;
	protected String temaDominante;
	protected final int anno;

	public Collezione(int cod, String tema, int a, Stilista s) throws EccezionePrecondizioni { 
     	codiceCollezione = cod;
		setTemaDominante(tema);
		if (a <= 0) throw new EccezionePrecondizioni("anno non valido");
		anno=a;
		if (s==null) throw new EccezionePrecondizioni("Lo stilista non puo' essere null");
		appartiene = s;
	}
	public int getCodiceCollezione() { return codiceCollezione; }
	public String getTemaDominante() { return temaDominante; }
	public int getAnno() { return anno; }
	public void setTemaDominante(String t) throws EccezionePrecondizioni { 
		if (t==null) throw new EccezionePrecondizioni("Il tema non puo' essere null");
		temaDominante=t; 
	}
	
	// Gestione associazione `appartiene'
	private Stilista appartiene = null;
	public Stilista getAppartiene() { 
		return appartiene; 
		// Si noti come posso evitare di generare EccezioneMolteplicita
		// anche se il vincolo di molt. e' 1..1.
		// Questo perche' ho deciso che il link e' immutabile e noto alla nascita
		// ed e' il costruttore che evita che il cliente passi uno stilista `null'.
	}
	
	public String toString() {
		return "Collezione " + codiceCollezione + "(" + this.getClass().getName() + "). Tema: " + temaDominante + ", " + anno + ", stilista " + appartiene;
	}
	
	
} //:~