package PC20050329;

import ProSW.*;
import java.util.*;

public class Sfilata {
	private String luogo;
	private Data dataInizio;
	private Data dataFine;
	
	public Sfilata(String l, Data di, Data df) throws EccezionePrecondizioni {
		setLuogo(l);
		setDataInizio(di);
		setDataFine(df);
	}
		
	public Data getDataInizio() { return dataInizio;} 
	public Data getDataFine()   { return dataFine;}
	public String getLuogo()    { return luogo;}
	
	public void setDataInizio(Data d) throws EccezionePrecondizioni {
		if (d==null) throw new EccezionePrecondizioni("La data non puo' essere null");
 		dataInizio = d;  // Nota: La versione della classe Data usata non permette side-effect!
	}
	public void setDataFine(Data d) throws EccezionePrecondizioni {
		if (d==null) throw new EccezionePrecondizioni("La data non puo' essere null");
 		dataFine = d; // Nota: La versione della classe Data usata non permette side-effect!
	}
	public void setLuogo(String l) throws EccezionePrecondizioni { 
		if (l==null) throw new EccezionePrecondizioni("Il luogo non puo' essere null");
		luogo=l; 
	}

	// Gestione associazione Presentata (1..*)
	private Set<Collezione> linkPresentata = new HashSet<Collezione>();

	public void inserisciLinkPresentata(Collezione collezione) 
		  throws EccezionePrecondizioni {
		if (collezione == null) throw new EccezionePrecondizioni("La collezione non puo' essere null");
	  	linkPresentata.add( collezione );
	}
	public Set<Collezione> getLinkPresentata() throws EccezioneMolteplicita {
		if (linkPresentata.size() < 1)
			throw new EccezioneMolteplicita("I vincoli di molteplicita' dell'associazione 'Presentata' sono violati");
		return (Set<Collezione>)((HashSet<Collezione>)linkPresentata).clone(); 
	}
	
	public String toString() {
		String result = "Sfilata in " + luogo + "(" + dataInizio + " - " + dataFine + ")";
		try {
			Iterator<Collezione> it = getLinkPresentata().iterator();
			while (it.hasNext()) {
				// '\n' e' il carattere di ritorno a capo
				Collezione c = it.next();
				result += "\n - " + c;
			}
		} catch(EccezioneMolteplicita em) {
			result += "\n" + em + "\nIgnoro";
		}
		return result;
	}
	
} //:~