package PC20050329;
import ProSW.*;

public class TipoLinkAcquista {
  private final PretAPorter pretaporter;
  private final Azienda azienda;
  private final int nCapi;

  public TipoLinkAcquista(PretAPorter x, Azienda y, int nc) throws EccezionePrecondizioni {
	  
	if (x == null) throw new EccezionePrecondizioni("pretaporter non puo' essere null");
	pretaporter = x;
	
	if (y == null) throw new EccezionePrecondizioni("azienda non puo' essere null");	
	azienda = y;
	
	if (nc <=0) throw new EccezionePrecondizioni("Il num. di capi deve essere > 0");	
	nCapi = nc;

  }
  
  public PretAPorter getPretAPorter() { return pretaporter; }
  public Azienda getAzienda() { return azienda; }
  public int getNCapi() { return nCapi; }

  
  public boolean equals(Object o) {
    if (o != null && getClass().equals(o.getClass())) {
      TipoLinkAcquista t = (TipoLinkAcquista)o;
      return pretaporter == t.pretaporter && azienda == t.azienda;
    }
    else return false;
  }
  public int hashCode() { return pretaporter.hashCode()+azienda.hashCode(); }
} //:~
